#include <SoftwareSerial.h>
#include "Definitions.h"

char serialData;
int temperature = 0;
int sensorData = 0;
int cordReelStatus = 0; //closed=0 open=1
SoftwareSerial mySerial(rx,tx);

void setup() {
  mySerial.begin(9600);
  pinMode(relay, OUTPUT);
  pinMode(motor_pin_1, OUTPUT);
  pinMode(motor_pin_2, OUTPUT);
  pinMode(led_r, OUTPUT);
  pinMode(led_g, OUTPUT);
  pinMode(led_b, OUTPUT);
  display_blink();
}

void loop() {
  // read temperature
  sensorData = analogRead(tmpSensor); 
  temperature = sensorData /2 ;

// check received serial data
  if(mySerial.available()>0){
    serialData = mySerial.read();
    // interpret received command
    switch (serialData) {
    case cmd_heater_on :
      digitalWrite(relay, HIGH);
      blue_to_orange(1000);  // heating time is 10s (not related to temperature yet)
      break;
    case cmd_heater_off :
      digitalWrite(relay, LOW);
      break;
    case cmd_cordreel  :
      if (cordReelStatus ==0){
        cordReel (up, 128);
        delay(2000);
        cordReel (off, 0);
        cordReelStatus = 1;
      }
      else if (cordReelStatus ==1){
        cordReel (down, 128);
        delay(2000);
        cordReel (off, 0);
        cordReelStatus = 0;
      }
      break;
    }
  } 
}

void display_show(int r, int g, int b){
  analogWrite(led_r, r);
  analogWrite(led_g, g);
  analogWrite(led_b, b);
}

void cordReel (int dirct, int spd){
  if (dirct == up){
    analogWrite(motor_pin_1, spd);
    analogWrite(motor_pin_2, 0);
  }
  else if (dirct == down){
    analogWrite(motor_pin_1, 0);
    analogWrite(motor_pin_2, spd);
  }
  else{
    digitalWrite(motor_pin_1, LOW);
    digitalWrite(motor_pin_2, LOW);
  }
}

void display_blink(void){
  for (int i=0; i<3; i++){
    analogWrite(led_r, 0);
    analogWrite(led_g, 0);
    analogWrite(led_b, 255);
    delay(700);
    analogWrite(led_r, 0);
    analogWrite(led_g, 0);
    analogWrite(led_b, 0);
    delay(700);
  }
}

void blue_to_orange(int intervals){
  for (int i=0; i<5; i++){
    analogWrite(led_r, 0 + i * 63 );
    analogWrite(led_g, 0 + i * 63);
    analogWrite(led_b, 255 - i * 63);
    delay(intervals);
  }
  for (int i=0; i<5; i++){
    analogWrite(led_r, 255 );
    analogWrite(led_g, 255 - i * 60);
    analogWrite(led_b, 0);
    delay(intervals);
  }
  analogWrite(led_r, 0 );
  analogWrite(led_g, 0);
  analogWrite(led_b, 0);
}
